

#property copyright "Copyright  2010, kourosh gold trade v1.0"
#property link      "kourosh1347@gmail.com"

#include <stdlib.mqh>
#include <WinUser32.mqh>

// exported variables
extern int OpenOrdersLimit = 2;
extern double BuyLots = 0.1;
extern double BuyLevel = 30;
extern double StopLevel = 70;

// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;

int NDigits = 4;   // used mostly for NormalizeDouble in Flex type blocks
int ObjCount = 0;  // count of all objects created on the chart, allows creation of objects with unique names


int init()
{
    NDigits = Digits;
    
    ObjectsDeleteAll();      // clear the chart
    
    
    Comment("");    // clear the chart
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
     }
     if (CountTrade(Symbol())<2)
          RsiBuy();
    RsiClose();
    
 
    
}



void RsiBuy()
{
  
    if ((iRSI(NULL, PERIOD_H1,14,PRICE_TYPICAL,2) < BuyLevel-5) && (iRSI(NULL,PERIOD_H1,14,PRICE_TYPICAL,1) < BuyLevel) && (iRSI(NULL, PERIOD_H1,14,PRICE_TYPICAL,0) > BuyLevel))
    { 
 
        BuyOrder4();
        
    }
}


void BuyOrder4()
{
   
    int ticket = -1;
    
    ticket = OrderSend(Symbol(), OP_BUY, BuyLots, Ask, 4, 0, 0, "GOLD ", 1, 0, Blue);
   
  
}

void RsiClose()
{
    if (iRSI(NULL, PERIOD_H1,14,PRICE_TYPICAL,0) >= StopLevel)
    {
        CloseOrder10();
        
    }
}

void CloseOrder10()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[30][2];
    for (int i = 0; i < orderstotal; i++)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_BUY || OrderSymbol() != Symbol() || OrderMagicNumber() != 1)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    
}

int CountTrade(string Symb)
//+------------------------------------------------------------------+
{
int count=0;
   //Searches for open trades
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {      
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if ( OrderSymbol() == Symb ) 
      {
         count++;
      }
   }
   
   return(count);
   
} 

int deinit()
{
 
    
    
}


